--library mgc_portable;
--use mgc_portable.qsim_logic.all;


library ieee;

use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.all;

library work;
use work.DEFINITIONS.all;



entity intinput is
      generic( 		size1 : integer :=1;
      			tel1 : integer :=8
      		);
      port (
	    	o   : out VECTORint(size1-1 downto 0);
	    	en  : in std_logic;
	    	clk : in std_logic;
	    	rst : in std_logic
	    );
end intinput;

architecture OPERATEUR of intinput is

type tableau is array (3 downto 0) of VECTORint (size1-1 downto 0);
signal tabvect : tableau;
signal number : integer := 0;
begin
	tabvect(0) (0) <= conv_std_logic_vector(1, tel1);
	tabvect(1) (0) <= conv_std_logic_vector(2, tel1);
	tabvect(2) (0) <= conv_std_logic_vector(3, tel1);
	tabvect(3) (0) <= conv_std_logic_vector(4, tel1);
--	tabvect(1) (0) <= conv_std_logic_vector(2, tel1);
--	tabvect(1) (1) <= conv_std_logic_vector(2, tel1);
--	tabvect(1) (2) <= conv_std_logic_vector(2, tel1);
--	tabvect(1) (3) <= conv_std_logic_vector(2, tel1);
--	tabvect(2) (0) <= conv_std_logic_vector(3, tel1);
--	tabvect(2) (1) <= conv_std_logic_vector(3, tel1);
--	tabvect(2) (2) <= conv_std_logic_vector(3, tel1);
--	tabvect(2) (3) <= conv_std_logic_vector(3, tel1);
--	tabvect(3) (0) <= conv_std_logic_vector(4, tel1);
--	tabvect(3) (1) <= conv_std_logic_vector(4, tel1);
--	tabvect(3) (2) <= conv_std_logic_vector(4, tel1);
--	tabvect(3) (3) <= conv_std_logic_vector(4, tel1);
--	tabvect(4) (0) <= conv_std_logic_vector(5, tel1);
--	tabvect(4) (1) <= conv_std_logic_vector(5, tel1);
--	tabvect(4) (2) <= conv_std_logic_vector(5, tel1);
--	tabvect(4) (3) <= conv_std_logic_vector(5, tel1);
--	tabvect(5) (0) <= conv_std_logic_vector(6, tel1);
--	tabvect(5) (1) <= conv_std_logic_vector(6, tel1);
--	tabvect(5) (2) <= conv_std_logic_vector(6, tel1);
--	tabvect(5) (3) <= conv_std_logic_vector(6, tel1);

  PRO : process (rst, clk, en)
  
  begin

    if rst = '1' then
      for i in 0 to (size1-1) loop
	  o(i) <= (others => '0');
      end loop;
    elsif (clk'event) and (clk = '1') then
      if en = '1' then
      	if  number < 4 then
	o <= tabvect(number);
      	number <= number +1;
	else
	number <= 0;
	end if;
      end if;
    end if;

  end process;

end OPERATEUR;
